//
// $History: AuxFuncs.pas $
// 
// *****************  Version 4  *****************
// User: Lvk          Date: 20.10.98   Time: 23:37
// Updated in $/Delphi 4.0/StreamFilter
// Modified email address + added persistent storage classes
// 
// *****************  Version 3  *****************
// User: Lvk          Date: 12.09.98   Time: 17:36
// Updated in $/Delphi 4.0/StreamFilter
// 
// *****************  Version 2  *****************
// User: Lvk          Date: 9.09.98    Time: 19:15
// Updated in $/Delphi 4.0/StreamFilter
// - Made library Delphi 3.x compatible
// - Fixed bug in encryption base classes
// - Replaced old email address
// 
// *****************  Version 1  *****************
// User: Lvk          Date: 20.07.98   Time: 18:12
// Created in $/Delphi 4.0/StreamFilter
// Auxiliary functions for bit rotation (ROL) and swapping of endian type
//

unit AuxFuncs;

// (C) Lasse Vgsther Karlsen, 1998
// lasse.karlsen@c2i.net

interface

{$IFDEF VER100}
type
	LongWord	= Integer;
{$ENDIF}

function SwapHiLo32(X: LongWord): LongWord;

{$IFDEF VER120}
// Delphi 4.x specific code
function SwapHiLo64(X: Int64): Int64;
{$ELSE}
// Delphi 3.x specific code
procedure SwapHiLo64(var Data);
function Min(A,B: Integer): Integer;
function Max(A,B: Integer): Integer;
{$ENDIF}

function ROL(a, s: LongWord): LongWord;
function ROR(a, s: LongWord): LongWord;

implementation

function SwapHiLo32(X: LongWord): LongWord;
asm
	bswap	eax
end; // function SwapHiLo(LongWord)

{$IFDEF VER120}
// Delphi 4.x specific code
function SwapHiLo64(X: Int64): Int64; overload;
var
	A	: array[0..1] of LongWord absolute X;
	B	: array[0..1] of LongWord absolute Result;
begin
	B[1] := SwapHiLo32(A[0]);
	B[0] := SwapHiLo32(A[1]);
end; // function SwapHiLo(Int64)
{$ELSE}
procedure SwapHiLo64(var Data);
var
	a,b		: LongWord;
	Temp	: packed record
		A,B	: LongWord;
	end absolute Data;
begin
	A := SwapHiLo32(Temp.A);
	B := SwapHiLo32(Temp.B);

	Temp.A := B;
	Temp.B := A;
end;

{$ENDIF}

function ROL(a, s: LongWord): LongWord;
asm
	mov		ecx,s
	rol		eax,cl
end; // function ROL

function ROR(a, s: LongWord): LongWord;
asm
	mov		ecx,s
	ror		eax,cl
end; // function ROL

{$IFDEF VER100}
// Delphi 3.x specific code
function Min(A,B: Integer): Integer;
begin
	if (A < B) then
		Result := A
	else
		Result := B;
end; // function Min

function Max(A,B: Integer): Integer;
begin
	if (A > B) then
		Result := A
	else
		Result := B;
end; // function Max
{$ENDIF}

end.
